searchNodes=[{"doc":"A client for connecting to GraphQL websockets that are implemented following the graphql-ws conventions. Example iex&gt; client = GraphQLWSClient . start_link ( url : &quot;ws://localhost:4000/socket&quot; ) ...&gt; ...&gt; { :ok , subscription_id } = GraphQLWSClient . subscribe ( ...&gt; client , ...&gt; &quot;subscription PostCreated { ... }&quot; ...&gt; ) ...&gt; ...&gt; { :ok , _ } = GraphQLWSClient . query ( ...&gt; client , ...&gt; &quot;mutation CreatePost { ... }&quot; ...&gt; ) ...&gt; ...&gt; receive do ...&gt; % GraphQLWSClient.Event { } = event -&gt; ...&gt; IO . inspect ( event ) ...&gt; end ...&gt; ...&gt; GraphQLClient . close ( client ) Custom Client If you want to run the client as part of a supervision tree in your application, you can also use GraphQLWSClient to create your own client. defmodule MyClient do use GraphQLWSClient , otp_app : :my_app end Then, you can configure your client using a config file: import Config config :my_app , MyClient , url : &quot;ws://localhost:4000/socket&quot; See GraphQLWSClient.Config.new/1 for a list of available options.","ref":"GraphQLWSClient.html","title":"GraphQLWSClient","type":"module"},{"doc":"Closes the connection to the websocket.","ref":"GraphQLWSClient.html#close/2","title":"GraphQLWSClient.close/2","type":"function"},{"doc":"Indicates whether the client is connected to the Websocket.","ref":"GraphQLWSClient.html#connected?/2","title":"GraphQLWSClient.connected?/2","type":"function"},{"doc":"Opens the connection to the websocket.","ref":"GraphQLWSClient.html#open/2","title":"GraphQLWSClient.open/2","type":"function"},{"doc":"Opens the connection to the websocket. Raises on error.","ref":"GraphQLWSClient.html#open!/2","title":"GraphQLWSClient.open!/2","type":"function"},{"doc":"Sends a GraphQL query or mutation to the websocket and returns the result. Example iex&gt; GraphQLWSClient . query ( ...&gt; client , ...&gt; &quot;query GetPost($id: ID!) { post(id: $id) { body } }&quot; , ...&gt; %{ &quot;id&quot; =&gt; 1337 } ...&gt; ) { :ok , %{ &quot;data&quot; =&gt; %{ &quot;posts&quot; =&gt; %{ &quot;body&quot; =&gt; &quot;Lorem Ipsum&quot; } } } }","ref":"GraphQLWSClient.html#query/4","title":"GraphQLWSClient.query/4","type":"function"},{"doc":"Sends a GraphQL query or mutation to the websocket and returns the result. Raises on error. Example iex&gt; GraphQLWSClient . query! ( ...&gt; client , ...&gt; &quot;query GetPost($id: ID!) { post(id: $id) { body } }&quot; , ...&gt; %{ &quot;id&quot; =&gt; 1337 } ...&gt; ) %{ &quot;data&quot; =&gt; %{ &quot;posts&quot; =&gt; %{ &quot;body&quot; =&gt; &quot;Lorem Ipsum&quot; } } }","ref":"GraphQLWSClient.html#query!/4","title":"GraphQLWSClient.query!/4","type":"function"},{"doc":"Starts a graphql-ws client. Options See GraphQLWSClient.Config.new/1 for a list of available options. Additionally, you may pass GenServer.options/0 .","ref":"GraphQLWSClient.html#start_link/1","title":"GraphQLWSClient.start_link/1","type":"function"},{"doc":"Starts a graphql-ws client using the given config and GenServer options. Options The first argument accept options as specified in GraphQLWSClient.Config.new/1 . The second argument accepts GenServer.options/0 .","ref":"GraphQLWSClient.html#start_link/2","title":"GraphQLWSClient.start_link/2","type":"function"},{"doc":"Sends a GraphQL subscription to the websocket and registers a listener process to retrieve events. Example iex&gt; GraphQLWSClient . subscribe ( ...&gt; client , ...&gt; &quot;&quot;&quot; ...&gt; subscription CommentAdded($postId: ID!) { ...&gt; commentAdded(postId: $postId) { body } ...&gt; } ...&gt; &quot;&quot;&quot; , ...&gt; %{ &quot;postId&quot; =&gt; 1337 } ...&gt; ) { :ok , &quot;2cb5b721-5172-4ed5-84e3-2810dc2ae892&quot; }","ref":"GraphQLWSClient.html#subscribe/5","title":"GraphQLWSClient.subscribe/5","type":"function"},{"doc":"Sends a GraphQL subscription to the websocket and registers a listener process to retrieve events. Raises on error. Example iex&gt; GraphQLWSClient . subscribe! ( ...&gt; client , ...&gt; &quot;&quot;&quot; ...&gt; subscription CommentAdded($postId: ID!) { ...&gt; commentAdded(postId: $postId) { body } ...&gt; } ...&gt; &quot;&quot;&quot; , ...&gt; %{ &quot;postId&quot; =&gt; 1337 } ...&gt; ) &quot;ec1d38c0-e6cc-4969-994b-67d5975240aa&quot;","ref":"GraphQLWSClient.html#subscribe!/5","title":"GraphQLWSClient.subscribe!/5","type":"function"},{"doc":"Removes a subscription. Example iex&gt; GraphQLWSClient . unsubscribe ( client , &quot;db809e6f-2575-4ceb-b1af-bc7b7d04e3fd&quot; ) :ok","ref":"GraphQLWSClient.html#unsubscribe/3","title":"GraphQLWSClient.unsubscribe/3","type":"function"},{"doc":"Removes a subscription. Raises on error. Example iex&gt; GraphQLWSClient . unsubscribe! ( client , &quot;c5a3cc39-ee73-4cdb-a553-ca4aab0d2b7f&quot; ) :ok","ref":"GraphQLWSClient.html#unsubscribe!/3","title":"GraphQLWSClient.unsubscribe!/3","type":"function"},{"doc":"Type for a client process.","ref":"GraphQLWSClient.html#t:client/0","title":"GraphQLWSClient.client/0","type":"type"},{"doc":"Type for a query, mutation or subscription string.","ref":"GraphQLWSClient.html#t:query/0","title":"GraphQLWSClient.query/0","type":"type"},{"doc":"Type for a subscription ID.","ref":"GraphQLWSClient.html#t:subscription_id/0","title":"GraphQLWSClient.subscription_id/0","type":"type"},{"doc":"A behaviour that is implemented by modules that use GraphQLWSClient .","ref":"GraphQLWSClient.Client.html","title":"GraphQLWSClient.Client","type":"behaviour"},{"doc":"Closes the connection to the server.","ref":"GraphQLWSClient.Client.html#c:close/1","title":"GraphQLWSClient.Client.close/1","type":"callback"},{"doc":"Connects to the server.","ref":"GraphQLWSClient.Client.html#c:open/1","title":"GraphQLWSClient.Client.open/1","type":"callback"},{"doc":"Connects to the server. Raises on error","ref":"GraphQLWSClient.Client.html#c:open!/1","title":"GraphQLWSClient.Client.open!/1","type":"callback"},{"doc":"Sends a query to the server and returns the result.","ref":"GraphQLWSClient.Client.html#c:query/3","title":"GraphQLWSClient.Client.query/3","type":"callback"},{"doc":"Sends a query to the server and returns the result. Raises on error.","ref":"GraphQLWSClient.Client.html#c:query!/3","title":"GraphQLWSClient.Client.query!/3","type":"callback"},{"doc":"Starts the client.","ref":"GraphQLWSClient.Client.html#c:start_link/1","title":"GraphQLWSClient.Client.start_link/1","type":"callback"},{"doc":"Sends a subscription to the server and returns the subscription ID.","ref":"GraphQLWSClient.Client.html#c:subscribe/4","title":"GraphQLWSClient.Client.subscribe/4","type":"callback"},{"doc":"Sends a subscription to the server and returns the subscription ID. Raises on error.","ref":"GraphQLWSClient.Client.html#c:subscribe!/4","title":"GraphQLWSClient.Client.subscribe!/4","type":"callback"},{"doc":"Removes the subscription for the given subscription ID.","ref":"GraphQLWSClient.Client.html#c:unsubscribe/2","title":"GraphQLWSClient.Client.unsubscribe/2","type":"callback"},{"doc":"Removes the subscription for the given subscription ID. Raises on error.","ref":"GraphQLWSClient.Client.html#c:unsubscribe!/2","title":"GraphQLWSClient.Client.unsubscribe!/2","type":"callback"},{"doc":"A struct containing the configuration for a client.","ref":"GraphQLWSClient.Config.html","title":"GraphQLWSClient.Config","type":"module"},{"doc":"Builds a new config. Options :backoff_interval - The number of milliseconds to wait before trying to reconnect to the server. :connect_on_start - Determines whether to immediately connect to the server as soon as the client is started. When set to false , you need to manually connect by calling GraphQLWSClient.open/1 . Defaults to true . :connect_timeout - The connection timeout. Defaults to 5000 . :driver - The driver module to use. Defaults to GraphQLWSClient.Drivers.Gun . :host - The host to connect to. This is ignored when :url is specified instead. :init_payload - The payload send together with the connection_init message. Is useful when you need to authenticate a connection with a token, for instance. :init_timeout - The number of milliseconds to wait for a connection_ack after initiating the connection. Defaults to 5000 . :path - The path on the server. This is ignored when :url is specified instead. Defaults to &quot;/&quot; . :port - The port to connect to. This is ignored when :url is specified instead. :upgrade_timeout - The number of milliseconds to wait for a connection upgrade. Defaults to 5000 . :url - The URL of the websocket to connect to. Overwrites the :host , :port and :path options.","ref":"GraphQLWSClient.Config.html#new/1","title":"GraphQLWSClient.Config.new/1","type":"function"},{"doc":"","ref":"GraphQLWSClient.Config.html#t:t/0","title":"GraphQLWSClient.Config.t/0","type":"type"},{"doc":"A event for a subscription.","ref":"GraphQLWSClient.Event.html","title":"GraphQLWSClient.Event","type":"module"},{"doc":"","ref":"GraphQLWSClient.Event.html#t:t/0","title":"GraphQLWSClient.Event.t/0","type":"type"},{"doc":"A struct passed to the used driver that contains information about the current connection.","ref":"GraphQLWSClient.Conn.html","title":"GraphQLWSClient.Conn","type":"module"},{"doc":"","ref":"GraphQLWSClient.Conn.html#t:t/0","title":"GraphQLWSClient.Conn.t/0","type":"type"},{"doc":"A behaviour that defines function to implement custom backends.","ref":"GraphQLWSClient.Driver.html","title":"GraphQLWSClient.Driver","type":"behaviour"},{"doc":"Connects to the socket and returns the updated GraphQLWSClient.Conn .","ref":"GraphQLWSClient.Driver.html#c:connect/1","title":"GraphQLWSClient.Driver.connect/1","type":"callback"},{"doc":"Disconnects from the socket.","ref":"GraphQLWSClient.Driver.html#c:disconnect/1","title":"GraphQLWSClient.Driver.disconnect/1","type":"callback"},{"doc":"Optional callback that prepares the :opts stored in the GraphQLWSClient.Conn . Can be used to set default values.","ref":"GraphQLWSClient.Driver.html#c:init/1","title":"GraphQLWSClient.Driver.init/1","type":"callback"},{"doc":"Parses a message received from the socket.","ref":"GraphQLWSClient.Driver.html#c:parse_message/2","title":"GraphQLWSClient.Driver.parse_message/2","type":"callback"},{"doc":"Pushes a message to the socket.","ref":"GraphQLWSClient.Driver.html#c:push_message/2","title":"GraphQLWSClient.Driver.push_message/2","type":"callback"},{"doc":"A message passed received by a driver.","ref":"GraphQLWSClient.Message.html","title":"GraphQLWSClient.Message","type":"module"},{"doc":"","ref":"GraphQLWSClient.Message.html#t:message_type/0","title":"GraphQLWSClient.Message.message_type/0","type":"type"},{"doc":"","ref":"GraphQLWSClient.Message.html#t:t/0","title":"GraphQLWSClient.Message.t/0","type":"type"},{"doc":"A driver using the :gun library to connect to the GraphQL websocket. Usage The Gun driver is configured as default driver using Jason as default encoder and decoder. However, you still need to install the particular libraries yourself if you want to use them, so add these to your deps. { :gun , &quot;~&gt; 2.0&quot; } , { :jason , &quot;~&gt; 1.4&quot; } , Custom JSON Library To customize the JSON library that is used by the Gun driver, you can set a custom :driver option when starting the client. GraphQLWSClient . start_link ( host : &quot;example.com&quot; , driver : { GraphQLWSClient.Drivers.Gun , json_library : Poison } , # more options here... ) Or you can set it in the configuration for your custom client. import Config config :my_app , MyGraphQLWSClient , driver : { GraphQLWSClient.Drivers.Gun , json_library : Poison }","ref":"GraphQLWSClient.Drivers.Gun.html","title":"GraphQLWSClient.Drivers.Gun","type":"module"},{"doc":"Exception that contains errors from a GraphQL query.","ref":"GraphQLWSClient.QueryError.html","title":"GraphQLWSClient.QueryError","type":"exception"},{"doc":"Callback implementation for Exception.message/1 .","ref":"GraphQLWSClient.QueryError.html#message/1","title":"GraphQLWSClient.QueryError.message/1","type":"function"},{"doc":"","ref":"GraphQLWSClient.QueryError.html#t:t/0","title":"GraphQLWSClient.QueryError.t/0","type":"type"},{"doc":"Exception that indicates a socket error.","ref":"GraphQLWSClient.SocketError.html","title":"GraphQLWSClient.SocketError","type":"exception"},{"doc":"Callback implementation for Exception.message/1 .","ref":"GraphQLWSClient.SocketError.html#message/1","title":"GraphQLWSClient.SocketError.message/1","type":"function"},{"doc":"","ref":"GraphQLWSClient.SocketError.html#t:cause/0","title":"GraphQLWSClient.SocketError.cause/0","type":"type"},{"doc":"","ref":"GraphQLWSClient.SocketError.html#t:t/0","title":"GraphQLWSClient.SocketError.t/0","type":"type"},{"doc":"MIT License Copyright (c) 2023 Tobias Casper Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the &quot;Software&quot;), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions: The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software. THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.","ref":"license.html","title":"License","type":"extras"},{"doc":"A client for connecting with GraphQL over Websockets following the graphql-ws conventions.","ref":"readme.html","title":"Readme","type":"extras"},{"doc":"The package can be installed by adding graphql_ws_client to your list of dependencies in mix.exs . If you are using the default configuration, you will also need the jason and gun packages (or provide a custom GraphQLWSClient.Driver instead). def deps do [ { :graphql_ws_client , &quot;~&gt; 0.1.0&quot; } , { :gun , &quot;~&gt; 2.0&quot; } , { :jason , &quot;~&gt; 1.4&quot; } , ] end","ref":"readme.html#installation","title":"Readme - Installation","type":"extras"},{"doc":"client = GraphQLWSClient . start_link ( url : &quot;ws://localhost:4000/socket&quot; ) { :ok , subscription_id } = GraphQLWSClient . subscribe ( client , &quot;subscription PostCreated { ... }&quot; ) { :ok , _ } = GraphQLWSClient . query ( client , &quot;mutation CreatePost { ... }&quot; ) receive do % GraphQLWSClient.Event { } = event -&gt; IO . inspect ( event ) end GraphQLClient . close ( client )","ref":"readme.html#usage","title":"Readme - Usage","type":"extras"},{"doc":"If you want to run the client as part of a supervision tree in your application, you can also use GraphQLWSClient to create your own client. defmodule MyClient do use GraphQLWSClient , otp_app : :my_app end Then, you can configure your client using a config file: import Config config :my_app , MyClient , url : &quot;ws://localhost:4000/socket&quot;","ref":"readme.html#custom-client","title":"Readme - Custom Client","type":"extras"},{"doc":"Documentation can be found at https://hexdocs.pm/graphql_ws_client or generated locally using mix docs .","ref":"readme.html#docs","title":"Readme - Docs","type":"extras"}]